## libzmq-58deca3fb35869370391ae053baec1dc249d8755.tar.gz

=== CMakeLists.txt ===
# CMake build script for ZeroMQ
project(ZeroMQ)

if(${CMAKE_SYSTEM_NAME} STREQUAL Darwin)
  cmake_minimum_required(VERSION 3.0.2)
else()
  cmake_minimum_required(VERSION 2.8.12)
endif()

include(CheckIncludeFiles)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckLibraryExists)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CMakeDependentOption)
include(CheckCXXSymbolExists)
include(CheckTypeSize)
include(FindThreads)
include(GNUInstallDirs)
include(CheckTypeSize)
include(CMakePackageConfigHelpers)

list(INSERT CMAKE_MODULE_PATH 0 "${CMAKE_CURRENT_SOURCE_DIR}")
set(ZMQ_CMAKE_MODULES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/builds/cmake/Modules)
list(APPEND CMAKE_MODULE_PATH ${ZMQ_CMAKE_MODULES_DIR})

include(TestZMQVersion)
include(ZMQSourceRunChecks)
include(ZMQSupportMacros)

option(ENABLE_ASAN "Build with address sanitizer" OFF)
if(ENABLE_ASAN)
  message(STATUS "Instrumenting with Address Sanitizer")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope -fno-omit-frame-pointer")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope -fno-omit-frame-pointer")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address -fsanitize-address-use-after-scope")
endif()

option (ENABLE_INTRINSICS "Build using compiler intrinsics for atomic ops" OFF)
if (ENABLE_INTRINSICS)
   message(STATUS "Using compiler intrinsics for atomic ops")
   add_definitions(-DZMQ_HAVE_ATOMIC_INTRINSICS)
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL Darwin)
  # Find more information: https://cmake.org/Wiki/CMake_RPATH_handling

  # Apply CMP0042: MACOSX_RPATH is enabled by default
  cmake_policy(SET CMP0042 NEW)

  # Add an install rpath if it is not a system directory
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  endif()

  # Add linker search paths pointing to external dependencies
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

check_cxx_compiler_flag("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
if(COMPILER_SUPPORTS_CXX11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
endif()
check_c_compiler_flag("-std=gnu11" COMPILER_SUPPORTS_C11)
if(COMPILER_SUPPORTS_C11)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
else()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
endif()

if(NOT MSVC)
  # clang 6 has a warning that does not make sense on multi-platform code
  check_cxx_compiler_flag("-Wno-tautological-constant-compare" CXX_HAS_TAUT_WARNING)
  if(CXX_HAS_TAUT_WARNING)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-tautological-constant-compare")
  endif()
  check_c_compiler_flag("-Wno-tautological-constant-compare" CC_HAS_TAUT_WARNING)
  if(CC_HAS_TAUT_WARNING)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-tautological-constant-compare")
  endif()
endif()

# Will be used to add flags to pkg-config useful when apps want to statically link
set(pkg_config_libs_private "")
set(pkg_config_names_private "")

option(WITH_OPENPGM "Build with support for OpenPGM" OFF)
option(WITH_VMCI "Build with support for VMware VMCI socket" OFF)

if(APPLE)
  option(ZMQ_BUILD_FRAMEWORK "Build as OS X framework" OFF)
endif()

# Disable webSocket transport
option(DISABLE_WS "Disable WebSocket transport" OFF)
option(WITH_NSS "Use NSS instead of builtin sha1" OFF)

if (NOT DISABLE_WS)
  list(APPEND sources
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_address.cpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_connecter.cpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_decoder.cpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_encoder.cpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_engine.cpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_listener.cpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_address.hpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_connecter.hpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_decoder.hpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_encoder.hpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_engine.hpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_listener.hpp
          ${CMAKE_CURRENT_SOURCE_DIR}/src/ws_protocol.hpp)
  set(ZMQ_HAVE_WS 1)

  if (WITH_NSS)
    find_package("NSS3")
    if (NSS3_FOUND)
      message(STATUS "Using NSS")
      include_directories(${NSS3_INCLUDE_DIRS})
      set(pkg_config_names_private "${pkg_config_names_private} nss3")
      set(pkg_config_libs_private "${pkg_config_libs_private} -lnss3")
      set(ZMQ_USE_NSS 1)
    else()
      message(FATAL_ERROR
              "nss is not installed. Install it, then run CMake again")
    endif()
  else()
    list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/external/sha1/sha1.c ${CMAKE_CURRENT_SOURCE_DIR}/external/sha1/sha1.h)
    message("Using builtin sha1")
    set(ZMQ_USE_BUILTIN_SHA1 1)
  endif()
endif()


# Select curve encryption library, defaults to tweetnacl
# To use libsodium instead, use --with-libsodium(must be installed)
# To disable curve, use --disable-curve

option(WITH_LIBSODIUM "Use libsodium instead of built-in tweetnacl" OFF)
option(ENABLE_CURVE "Enable CURVE security" ON)

if(NOT ENABLE_CURVE)
  message(STATUS "CURVE security is disabled")
elseif(WITH_LIBSODIUM)
  find_package(Sodium)
  if(SODIUM_FOUND)
    message(STATUS "Using libsodium for CURVE security")
    include_directories(${SODIUM_INCLUDE_DIRS})
    set(ZMQ_USE_LIBSODIUM 1)
    set(ZMQ_HAVE_CURVE 1)
  else()
    message(FATAL_ERROR
      "libsodium is not installed. Install it, then run CMake again")
  endif()
else()
  message(STATUS "Using tweetnacl for CURVE security")
  list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/src/tweetnacl.c)
  set(ZMQ_USE_TWEETNACL 1)
  set(ZMQ_HAVE_CURVE 1)
endif()

set(SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

if(EXISTS "${SOURCE_DIR}/.git")
  option(ENABLE_DRAFTS "Build and install draft classes and methods" ON)
else()
  option(ENABLE_DRAFTS "Build and install draft classes and methods" OFF)
endif()
if(ENABLE_DRAFTS)
  option (ENABLE_RADIX_TREE "Use radix tree implementation to manage subscriptions" ON)
  add_definitions(-DZMQ_BUILD_DRAFT_API)
  set(pkg_config_defines "-DZMQ_BUILD_DRAFT_API=1")
else()
  option (ENABLE_RADIX_TREE "Use radix tree implementation to manage subscriptions" OFF)
  set(pkg_config_defines "")
endif()

if (ENABLE_RADIX_TREE)
   message(STATUS "Using radix tree implementation to manage subscriptions")
   add_definitions(-DZMQ_USE_RADIX_TREE)
endif()

option(WITH_MILITANT "Enable militant assertions" OFF)
if(WITH_MILITANT)
  add_definitions(-DZMQ_ACT_MILITANT)
endif()

set(API_POLLER "" CACHE STRING "Choose polling system for zmq_poll(er)_*. valid values are
  poll or select [default=poll unless POLLER=select]")

set(POLLER "" CACHE STRING "Choose polling system for I/O threads. valid values are
  kqueue, epoll, devpoll, pollset, poll or select [default=autodetect]")

if(NOT MSVC)
  if(POLLER STREQUAL "")
    check_cxx_symbol_exists(kqueue sys/event.h HAVE_KQUEUE)
    if(HAVE_KQUEUE)
      set(POLLER "kqueue")
    endif()
  endif()

  if(POLLER STREQUAL "")
    check_cxx_symbol_exists(epoll_create sys/epoll.h HAVE_EPOLL)
    if(HAVE_EPOLL)
      set(POLLER "epoll")
      check_cxx_symbol_exists(epoll_create1 sys/epoll.h HAVE_EPOLL_CLOEXEC)
      if(HAVE_EPOLL_CLOEXEC)
        set(ZMQ_IOTHREAD_POLLER_USE_EPOLL_CLOEXEC 1)
      endif()
    endif()
  endif()

  if(POLLER STREQUAL "")
    set(CMAKE_EXTRA_INCLUDE_FILES sys/devpoll.h)
    check_type_size("struct pollfd" DEVPOLL)
    set(CMAKE_EXTRA_INCLUDE_FILES)
    if(HAVE_DEVPOLL)
      set(POLLER "devpoll")
    endif()
  endif()

  if(POLLER STREQUAL "")
    check_cxx_symbol_exists(pollset_create sys/pollset.h HAVE_POLLSET)
    if(HAVE_POLLSET)
      set(POLLER "pollset")
    endif()
  endif()

  if(POLLER STREQUAL "")
    check_cxx_symbol_exists(poll poll.h HAVE_POLL)
    if(HAVE_POLL)
      set(POLLER "poll")
    endif()
  endif()
endif()

if(POLLER STREQUAL "")
  if(WIN32)
    set(HAVE_SELECT 1)
  else()
    check_cxx_symbol_exists(select sys/select.h HAVE_SELECT)
  endif()
  if(HAVE_SELECT)
    set(POLLER "select")
  else()
    message(FATAL_ERROR
      "Could not autodetect polling method")
  endif()
endif()

if(POLLER STREQUAL "kqueue"
  OR POLLER STREQUAL "epoll"
  OR POLLER STREQUAL "devpoll"
  OR POLLER STREQUAL "pollset"
  OR POLLER STREQUAL "poll"
  OR POLLER STREQUAL "select")
  message(STATUS "Using polling method in I/O threads: ${POLLER}")
  string(TOUPPER ${POLLER} UPPER_POLLER)
  set(ZMQ_IOTHREAD_POLLER_USE_${UPPER_POLLER} 1)
else()
  message(FATAL_ERROR "Invalid polling method")
endif()

if(POLLER STREQUAL "epoll" AND WIN32)
  message(STATUS "Including wepoll")
  list(APPEND sources ${CMAKE_CURRENT_SOURCE_DIR}/external/wepoll/wepoll.c ${CMAKE_CURRENT_SOURCE_DIR}/external/wepoll/wepoll.h)
endif()

if(API_POLLER STREQUAL "")
  if(POLLER STREQUAL "select")
    set(API_POLLER "select")
  else()
    set(API_POLLER "poll")
  endif()
endif()

message(STATUS "Using polling method in zmq_poll(er)_* API: ${API_POLLER}")
string(TOUPPER ${API_POLLER} UPPER_API_POLLER)
set(ZMQ_POLL_BASED_ON_${UPPER_API_POLLER} 1)

execute_process(COMMAND getconf LEVEL1_DCACHE_LINESIZE OUTPUT_VARIABLE CACHELINE_SIZE ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(CACHELINE_SIZE STREQUAL "" OR CACHELINE_SIZE EQUAL 0 OR CACHELINE_SIZE EQUAL -1)
  set(ZMQ_CACHELINE_SIZE 64)
else()
  set(ZMQ_CACHELINE_SIZE ${CACHELINE_SIZE})
endif()
message(STATUS "Using ${ZMQ_CACHELINE_SIZE} bytes alignment for lock-free data structures")

if(NOT CYGWIN)
  # TODO cannot we simply do 'if(WIN32) set(ZMQ_HAVE_WINDOWS ON)' or similar?
  check_include_files(windows.h ZMQ_HAVE_WINDOWS)
endif()

if (WIN32)
    # from https://stackoverflow.com/a/40217291/2019765
    macro(get_WIN32_WINNT version)
        if (CMAKE_SYSTEM_VERSION)
            set(ver ${CMAKE_SYSTEM_VERSION})
            string(REGEX MATCH "^([0-9]+).([0-9])" ver ${ver})
            string(REGEX MATCH "^([0-9]+)" verMajor ${ver})
            # Check for Windows 10, b/c we'll need to convert to hex 'A'.
            if ("${verMajor}" MATCHES "10")
                set(verMajor "A")
                string(REGEX REPLACE "^([0-9]+)" ${verMajor} ver ${ver})
            endif ("${verMajor}" MATCHES "10")
            # Remove all remaining '.' characters.
            string(REPLACE "." "" ver ${ver})
            # Prepend each digit with a zero.
            string(REGEX REPLACE "([0-9A-Z])" "0\\1" ver ${ver})
            set(${version} "0x${ver}")
        endif(CMAKE_SYSTEM_VERSION)
    endmacro(get_WIN32_WINNT)

    get_WIN32_WINNT(ZMQ_WIN32_WINNT_DEFAULT)
    message(STATUS "Detected _WIN32_WINNT from CMAKE_SYSTEM_VERSION: ${ZMQ_WIN32_WINNT_DEFAULT}")

    # TODO limit _WIN32_WINNT to the actual Windows SDK version, which might be different from the default version installed with Visual Studio
    if(MSVC_VERSION STREQUAL "1500" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.0")
        set(ZMQ_WIN32_WINNT_LIMIT "0x0600")
    elseif(MSVC_VERSION STREQUAL "1600" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.1")
        set(ZMQ_WIN32_WINNT_LIMIT "0x0601")
    elseif(MSVC_VERSION STREQUAL "1700" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.1")
        set(ZMQ_WIN32_WINNT_LIMIT "0x0601")
    elseif(MSVC_VERSION STREQUAL "1800" AND CMAKE_SYSTEM_VERSION VERSION_GREATER "6.2")
        set(ZMQ_WIN32_WINNT_LIMIT "0x0602")
    endif()
    if(ZMQ_WIN32_WINNT_LIMIT)
        message(STATUS "Mismatch of Visual Studio Version (${MSVC_VERSION}) and CMAKE_SYSTEM_VERSION (${CMAKE_SYSTEM_VERSION}), limiting _WIN32_WINNT to ${ZMQ_WIN32_WINNT_LIMIT}, you may override this by setting ZMQ_WIN32_WINNT")
        set(ZMQ_WIN32_WINNT_DEFAULT "${ZMQ_WIN32_WINNT_LIMIT}")
    endif()

=== packaging/debian/control ===
Source: zeromq
Section: libs
Priority: optional
Maintainer: libzmq Developers <zeromq-dev@lists.zeromq.org>
Build-Depends: debhelper (>= 9),
 dh-autoreconf,
 libkrb5-dev,
 libnorm-dev,
 libpgm-dev,
 libsodium-dev,
 libunwind-dev | libunwind8-dev | libunwind7-dev,
 libnss3-dev,
 libgnutls28-dev,
 pkg-config,
 asciidoc-base | asciidoc, xmlto,
Standards-Version: 3.9.8
Homepage: http://www.zeromq.org/

Package: libzmq5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: lightweight messaging kernel (shared library)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the libzmq shared library.

Package: libzmq3-dev
Architecture: any
Section: libdevel
Depends: libzmq5 (= ${binary:Version}), ${misc:Depends},
 libkrb5-dev,
 libnorm-dev,
 libpgm-dev,
 libsodium-dev,
 libunwind-dev | libunwind8-dev | libunwind7-dev,
 libnss3-dev,
 libgnutls28-dev,
Conflicts: libzmq-dev, libzmq5-dev
Replaces: libzmq5-dev
Provides: libzmq5-dev
Multi-Arch: same
Description: lightweight messaging kernel (development files)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ development libraries and header files.

Package: libzmq5-dbg
Architecture: any
Priority: extra
Section: debug
Depends: libzmq5 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: lightweight messaging kernel (debugging symbols)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the debugging symbols for the ZeroMQ library.
